bitel.billing.server.contract.bean

## Class ContractPatternManager

- java.lang.Object
- - bitel.billing.server.contract.bean.ContractPatternManager

-     public class ContractPatternManager
      extends java.lang.Object

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected static org.apache.log4j.Logger` | `logger`
    `static java.lang.String` | `TABLE_CONTRACT_PATTERN`
    `static java.lang.String` | `TITLE_PARAM_CARD`
    `static java.lang.String` | `TITLE_PARAM_CARD_SERIES`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ContractPatternManager(java.sql.Connection con)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static java.lang.String` | `getContractTitle(java.sql.Connection con, ContractPattern pattern, java.util.Calendar date)`
    `static java.lang.String` | `getContractTitle(java.sql.Connection con, ContractPattern pattern, java.util.Calendar date, java.util.Map<java.lang.String,java.lang.Object> titleParams)` Получение имени договора по шаблону
    `java.util.Map<java.lang.Integer,org.w3c.dom.Document>` | `getListPatternData()`
    `ContractPattern` | `getPattern(int id)` Получает шаблон договора по его ID
    `java.util.Map<java.lang.Integer,java.lang.Integer>` | `getPatternParameterGroupCountMap()` Возвращает Map содержащий коды групп параметров договоров и кол-ва шаблонов в каждой из них ("SELECT pgid, COUNT(*) FROM contract_pattern GROUP BY pgid")
    `java.util.List<IdTitle>` | `getPatternTitleList()`
    `static boolean` | `isContractTitleDuplicated(java.lang.String title, boolean add, int notVerifyContractId, java.sql.Connection con)` Проверка на дубликат названия договора.
    `static void` | `removeContractTitleFromLastTitles(int contractId, java.sql.Connection con)`
    `static void` | `removeContractTitleFromLastTitles(java.lang.String title)` Удалит из списка последних созданных названий ,если такой имеется и title !
    `static void` | `removeLastTitles()`
    `void` | `setDataPattern(int idPattern, org.w3c.dom.Document data)`
    `void` | `updateContaractPattern(int id, ContractPattern pattern)` Обновляет шаблона договора

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### TABLE_CONTRACT_PATTERN

          public static final java.lang.String TABLE_CONTRACT_PATTERN

      See Also:
        Constant Field Values

    - #### TITLE_PARAM_CARD

          public static final java.lang.String TITLE_PARAM_CARD

      See Also:
        Constant Field Values

    - #### TITLE_PARAM_CARD_SERIES

          public static final java.lang.String TITLE_PARAM_CARD_SERIES

      See Also:
        Constant Field Values

    - #### logger

          protected static final org.apache.log4j.Logger logger

  - ### Constructor Detail

    - #### ContractPatternManager

          public ContractPatternManager(java.sql.Connection con)

  - ### Method Detail

    - #### getPattern

          public ContractPattern getPattern(int id)

      Получает шаблон договора по его ID
      Parameters:
        `id` - код шаблона
      Returns:

    - #### updateContaractPattern

          public void updateContaractPattern(int id,
                                             ContractPattern pattern)

      Обновляет шаблона договора
      Parameters:
        `id` - код шаблона, "-1" - если новый
        `pattern` - шаблон

    - #### getContractTitle

          public static java.lang.String getContractTitle(java.sql.Connection con,
                                                          ContractPattern pattern,
                                                          java.util.Calendar date)
                                                   throws ru.bitel.bgbilling.common.BGException

      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### getContractTitle

          public static java.lang.String getContractTitle(java.sql.Connection con,
                                                          ContractPattern pattern,
                                                          java.util.Calendar date,
                                                          java.util.Map<java.lang.String,java.lang.Object> titleParams)
                                                   throws ru.bitel.bgbilling.common.BGException

      Получение имени договора по шаблону
      Parameters:
        `con` - соединение с базой данных
        `pattern` - шаблон договора
        `date` - дата
        `titleParams` - параметры
      Returns:
        номер договора
      Throws:
        `ru.bitel.bgbilling.common.BGException`

    - #### isContractTitleDuplicated

          public static boolean isContractTitleDuplicated(java.lang.String title,
                                                          boolean add,
                                                          int notVerifyContractId,
                                                          java.sql.Connection con)

      Проверка на дубликат названия договора. Проверяется как в БД так и в список недавно созданных.
      Но имейте ввиду, если вы этот title получили из getContractTitle, то нет смысла проверять, так как результат будет в любом случае false.
      Parameters:
        `title` - - название
        `add` - - если true, то если дубликата нет, то переданное название добавляется в список последних созданных.
        `notVerifyContractId` - - код договора для которого не будет производиться проверка на дубликат, передавать -1 если не нужен пар.
        `con` -
      Returns:
        false - если дубликата нет или title == null.

    - #### removeContractTitleFromLastTitles

          public static void removeContractTitleFromLastTitles(int contractId,
                                                               java.sql.Connection con)

    - #### removeContractTitleFromLastTitles

          public static void removeContractTitleFromLastTitles(java.lang.String title)

      Удалит из списка последних созданных названий ,если такой имеется и title != null

    - #### removeLastTitles

          public static void removeLastTitles()

    - #### getListPatternData

          public java.util.Map<java.lang.Integer,org.w3c.dom.Document> getListPatternData()

      Returns:
        Map содержащий все не пустые data, из каждого шаблона, ключ-id шаблона

    - #### getPatternTitleList

          public java.util.List<IdTitle> getPatternTitleList()

    - #### setDataPattern

          public void setDataPattern(int idPattern,
                                     org.w3c.dom.Document data)

      Parameters:
        `idPattern` - - id шаблона в котором будем заменять data
        `data` - - Document

    - #### getPatternParameterGroupCountMap

          public java.util.Map<java.lang.Integer,java.lang.Integer> getPatternParameterGroupCountMap()
                                                                                              throws ru.bitel.bgbilling.common.BGException

      Возвращает Map содержащий коды групп параметров договоров и кол-ва шаблонов в каждой из них ("SELECT pgid, COUNT(*) FROM contract_pattern GROUP BY pgid")
      Returns:
        Map в какой группе сколько договоров
      Throws:
        `ru.bitel.bgbilling.common.BGException`